Überblick

Es gibt immer wieder die Anforderung eigene Listen an Spalten- und Format- Vorgaben von Bauherren bzw. Kunden anzupassen.

Das hier beschrieben Tool „ListMatching“ (Excel-Mappe/VBA) erzeugt per Knopfdruck aus einer eigenen „QuellListe“ unter Verwendung einer leicht konfigurierbaren „Zuordnungstabelle“ eine neue „ZielListe“, die den Vorgaben des Kunden entspricht. Auf der Basis der einmalig konfigurierten „Zuordnungstabelle“ lässt sich auch die „Rückkonvertierung“ der „ZielListe“ in das „QuellListen“ -format per Knopfdruck realisieren.


Schnellstart

Zum Auslieferungsumfang des Tools „ListMatching“ gehört ein Ordner „BeispielListen“. Dieser enthält eine „QuellListe....xls“, eine „VorgabeListe...xls“ und eine „ZielListe...xls“.

Im Auslieferungszustand ist die im Tool „ListMatching“ enthaltene Zuordnungstabelle (entsprechend „VorgabeListe...xls“ ) bereits zu diesen BeispielListen passend konfiguriert. Die Voreinstellungen auf der Programmoberfläche sind ebenfalls bereits korrekt gesetzt.

Damit kann das Tool „ListMatching“ ohne weitere Vorbereitungen direkt mit diesen Beispiellisten genutzt werden. Nach dem Betätigen des Buttons <Matching> ist aus dem Ordner „BeispielListen“ die „QuellListe....xls“ mit dem Blatt „Query“ auszuwählen. Es wird danach automatisch eine ZielListe erzeugt, die bezüglich der Spaltenanordnung der Beispielliste „ZielListe...xls“ entspricht.

Für den Test des Rückweges ist der Button <ReImport-Matching> zu drücken und die (mit Daten angereicherte) „ZielListe.xls“ aus dem Ordner „BeispielListen“ zu verwenden.

Für die echte Inbetriebnahme mit eigenen Listen sind eine eigene „QuellListe“ und die eigene „VorgabeListe“ Voraussetzung. Über den Button <Zuordnungstabelle konfigurieren> ist Vorgabe-Spaltendefinition der VorgabeListe zu hinterlegen ...

Gutes Gelingen!


Beschreibung im Detail

Das folgende Schaubild stellt den prinzipiellen Ablauf am Beispiel einer 3-spaltigen QuellListe dar. Blaue Pfeile zeigen den Ablauf „Matching der QuellListe zur ZielListe“ (Hinweg), graue Pfeile den Ablauf „ReMatching der (gefüllten) ZielListe zur ReImportListe (Rückweg) dar:

siehe Prinzip „ListMatching“

More:

„Matching" der QuellListe zur Zielliste

Außerhalb des Tools: Ergänzung von Daten

„Matching" der ZielListe zur ReImportListe

Einrichtung der Zuordnungstabelle

Voreinstellungen...

Wiederholungen


„Matching" der QuellListe zur Zielliste

ListMatching: Anpassung von eigenen Listen an Vorgabelisten

„Matching“ der QuellListe zur Zielliste

Nach dem Start des Tools „ListMatching“ wird der Nutzer nach dem Drücken des Buttons <Matching> aufgefordert, die QuellListe(1) auszuwählen. Nach Bestätigung der gewählten QuellListe erzeugt das Tool „ListMatching“ auf der Basis der integrierten Zuordnungstabelle(2) die ZielListe(3).
Wenn die Zuordnungstabelle im Vorfeld korrekt angepasst wurde, entspricht die Zieltabelle den Vorgaben unseres Kunden (VorgabeListe).


Außerhalb des Tools: Ergänzung von Daten

Die ZielListe wird danach eventuell um Datensätze ergänzt, Feldinhalte werden außerhalb unserer Hoheit geändert(4).


„Matching" der ZielListe zur ReImportListe

ListMatching: Anpassung von eigenen Listen an Vorgabelisten

„Matching“ der ZielListe zur ReImportListe

Die mit Daten/Inhalten angereicherte ZielListe(5) lässt sich mit dem Button <ReImport-Matching> unter Nutzung der selben, integrierten Zuordnungstabelle in die Ursprungsform (bezüglich Spaltenanordnung) zurück konvertieren.


Einrichtung der Zuordnungstabelle

Im Vorfeld ist die Zuordnungstabelle-Tabelle korrekt zu konfigurieren:

Siehe Bild: Zuordnungstabelle

1) Zeilen 8-12: Raum für den Spaltenkopf der VorgabeListe,

2) Zeile 5: Zuordnungen der QuellListen-Spalten zu den Spalten der VorgabeListe (Zeilen 8-12)

3) Zeile 2, Spalte 5: Vorgabe der Anzahl der abzuarbeitenden Spalten

4) optional: Nur wenn ein „ReImport-Matching“ erforderlich ist, sind die Zeilen 16-20 mit dem Spaltenkopf der QuellListe zu füllen.


Wiederholungen

Wenn mehrere aufeinanderfolgende Wiederholungen des Datentausches (Matching, Ergänzung von Daten, ReImportMatching) womöglich mit mehreren verschiedenen Listen parallel zu erwarten sind, empfiehlt sich folgende Vorgenhensweise:

Je QuellListe wird ein Tool „ListMatching“ per Kopie erzeugt und eingerichtet (Zuordnungstabelle und Voreinstellungen Zuordnungstabelle). Nach Fertigstellung wir der Dateiname des eingerichteten Excel-Tools in Abhängigkeit vom Namen der QuellListe festgelegt. Damit können beliebig viele Matching-Konfigurationen parallel gehalten und beliebig oft in allen Richtungen benutzt werden. Im Wiederholungsfalle ist kein Neukonfiguration erforderlich.


Support, Kontakt

Diese VB-Anwendung ist Freeware und kann ohne Lizenzbeschränkungen verwendet werden. Es wird keinerlei Haftung für eventuelle Programmfehler und daraus resultierende Folgeschäden übernommen.

Der Support für diese Anwendung per E-Mail ist rein freiwilliger Natur. Es besteht keinerlei Verpflichtung Anfragen bzw. Mängel innerhalb bestimmter Fristen zu beantworten bzw. zu beheben.

Kontakt

ralf.bergemann@vattenfall.de


Prinzip-Bild „ListMatching"

Prinzip-Bild „ListMatching“


Bedienoberfläche


Zuordnungstabelle


Voreinstellungen Zuordnungstabelle


Begriffe

QuellListe

VorgabeListe /-Definition

ZielListe

Zuordnungstabelle (auch: MatchingTabelle)

ReImportListe

Matching

ReImport-Matching


Matching

Matching ist eine Methode, um die Spalten einer Liste durch gezielte Umordnung so anzupassen, dass sie inhaltlich korrekt zu einer anderen Liste passen. Dies gilt auch, wenn die Spaltenkopfbeschreibungen der inhaltlich zueinander passenden Spalten der beiden Listen nicht übereinstimmen (also verschiedene Begriffe für gleiche Inhalte verwendet werden).
Zur vorherigen Definition der korrekten Spaltenzuordnungen wird eine Zuordnungstabelle genutzt.


QuellListe

Excel-Liste, die an die Spaltenzuordnungen und Formate einer VorgabeListe anzupassen ist.


ReImportListe

Die ReImportListe entsteht, wenn eine ZielListe (eine Liste, die der Vorgabedefinition entspricht) durch "Matching" in umgekehrter Richtung in die Form der ursprünglichen QuellListe zurückkonvertiert wird.


ReImport-Matching

Entspricht dem Begriff „Matching“. In diesem Falle ist der Rückfluss der Daten gemeint. Die beim „Matching“ erzeugte, danach mit Daten angereicherte ZielListe wird auf der Basis der selben Zuordnungstabelle in die Ursprungsform zurück konvertiert.


VorgabeListe /-Definition

Listenkopf/Spaltenköpfe, die unser Kunde als Vorgabe definiert hat. Meist liegen Spaltenköpfe mit Erklärungen vor.


ZielListe

Diese Liste entsteht aus der QuellListe. Gemäß den Vorgaben in der Zuordnungstabelle wird diese Liste durch "Matching" neu erzeugt. Die Spalten der QuellListe werden in angepasster Reihenfolge in die ZielListe kopiert.


Zuordnungstabelle (auch: MatchingTabelle)

Eine im Tool „ListMatching“ integrierte, leicht anpassbare Tabelle.Sie kann über die Bedienoberfläche mit dem Button < Zuordnungstabelle konfigurieren> zur Bearbeitung geöffnet werden. Sie enthält die Spaltenköpfe und Zielformate der VorgabeDefinition und zusätzlich die Zuordnung, welche Spalte der QuellListe auf welche Spalte der ZielListe zu kopieren ist (gemäß VorgabeListe).


Voreinstellungen...

Im Tool „ListMatching“ kann über den Button <Voreinstellungen Zuordnungstabelle ...> festgelegt werden, welche Zeilen der mehrzeiligen Vorgabeliste in die ZielListe übernommen werden.

In analoger Weise funktioniert dies für das „ReImport-Matching“